<html lang="en" xmns:th="http://www.thymeleaf.org"
		xmlns:layout="http://ultraq.net.nz/thymeleaf/layout"
		layout:decorate="~{fragments/layout}">
<head>
	<title>Page Orders</title>
</head>

<body>

	<div layout:fragment="content">
		<h1>ORDERS API</h1>
		
		<button class="btn btn-primary" onclick="newOrder()">New Order</button>
		<button class="btn btn-primary" onclick="allOrder()">Semua Transaksi</button>
		<br>
		<br>
		
		<div id="main-contain"></div>
		<div id="data-list"></div>
		
		<script>
		
		
		
		var tempStok = 0;
		
		
			function formOrder(headerId){
				$.ajax({
						url: "/api/product",
						type: "get",
						contentType: "application/json",
						success: function(data){
					
							var str = "<table class = 'table'>"
								str += "<tr>"
								str += "<td>Product</td>"
								str += "<td><select class='form-control' id='product_id' onchange ='getPrice(this.value)'>"
								str += "<option id ='idProduct' value = 0 >-- Select Product -- </option>"
								for(var i = 0; i<data.length; i++){
									str += "<option value = "+data[i].id+">"+data[i].productName+"</option>"
								}
								str += "</select></td>"
								str += "</tr>"
								str += "<tr>"
								str += "<td>Price</td>"
								str += "<td><input disabled class='form-control' type='number' id='product_price'>"
								str += "</tr>"
								str += "<tr>"
								str += "</td>"
								str += "<td>Quantity</td>"
								str += "<td><input type='number' onkeyup='validateStok()' class='form-control' id='quantity'></td>"
								str += "</tr>"
								str += "<tr>"
								str += "<td><button class='btn btn-success' onclick = 'addOrder("+headerId+")' >Tambah Item</button></td>"
								str += "</tr>"
								str += "</table>"
								$('#main-contain').html(str)
						}
					})
			}
			
			function addNewOrder(){
				
				var formdata = '{'
					formdata += '"reference":"",'
					formdata += '"amount":""'
					formdata += '}'
				
				$.ajax({
					url: "/api/orderheader/add",
					type: "post",
					contentType: "application/json",
					data: formdata,
					success:function(){
						$.ajax({
							url: "/api/headerid",
							type: "get",
							contentType: "application/json",
							success: function(headerId){
								formOrder(headerId);								
							}
						})	
					}
				})
				
			}
			function newOrder(){
				$.ajax({
					url: "/api/headerid",
					type: "get",
					contentType: "application/json",
					success: function(headerId){
						if(headerId==0){
							addNewOrder();
						}else{
							formOrder(headerId);	
							showOrder(headerId);
						}								
					}
				})
			}
			
			function getPrice(id){
				if(id>0){					
					$.ajax({
						url: "/api/product/"+id,
						type: "get",
						contentType: "application/json",
						success: function(data){
							$('#product_price').val(data.productPrice)
							$('#quantity').attr('max', data.productStok)
							$('#quantity').attr('min', 1)
							tempStok = data.productStok;
						}
					})
				}else{
					$('#product_price').val(0)
				}
			}
			
			function validateStok(){
				if ($('#quantity').val()>tempStok){
					$('#quantity').val(tempStok)
				}
			}
			
			function addOrder(headerId){
				var price = $('#product_price').val();
				var productId = $('#product_id').val();
				var quanty = $('#quantity').val();
				
				var input = '{'
					input += '"headerId":'+headerId+','
					input += '"price":'+price+','
					input += '"productId":'+productId+','
					input += '"quantity":'+quanty+''
					input += '}'
					
				$.ajax({
					url: '/api/orderdetail/add',
					type: 'post',
					contentType: 'application/json',
					data: input,
					success: function(){
						showOrder(headerId)
					}
				})
				
				
			}
			
			function showOrder(headerId){
				$.ajax({
					url: '/api/orderdetail/'+headerId+'',
					type: 'get',
					contentType: 'application/json',
					success: function(data){
						var totalAll = 0;
						var str = "<table class = 'table'>"
							str += "<tr>"
							str += "<td>Reference</td>"
							str += "<td>Product</td>"
							str += "<td>Price</td>"
							str += "<td>Quantity</td>"
							str += "<td>Total</td>"
							str += "<td>Action</td>"
							str += "</tr>"
						for(var i =0 ; i< data.length;i++){
							totalAll += (data[i].quantity*data[i].product.productPrice)
							str += "<tr>"
							str += "<td>"+data[i].orderHeader.reference+"</td>"
							str += "<td>"+data[i].product.productName+"</td>"
							str += "<td>"+data[i].product.productPrice+"</td>"	
							str += "<td>"+data[i].quantity+"</td>"	
							str += "<td>"+data[i].quantity*data[i].product.productPrice+"</td>"	
							str += "<td><button type ='button'>Hapus</button></td>"	
							str += "</tr>"
							}
							str += "<tr><td colspan = '4'>Total Amount</td>"
							str += "<td><input id = 'totalAmount' value="+totalAll+" disabled></td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td><button onclick='confirmModal("+headerId+")'>Checkout</button></td>"
							str += "</tr>"
							str += "</table>"
							$('#data-list').html(str)
					}
				})
			}
			
			function confirmModal(headerId){
				$.ajax({
					url: '/api/orderdetail/'+headerId,
					type: 'get',
					contentType: 'application/json',
					success: function(data){
						var str = "<h5>Apakah anda yakin ingin checkout barang ini : </h5>"
							str += "<table class ='table table-border-borderless'>"
							str += "<thead>"
							str += "<tr>"
							str += "<th>No</th>"
							str += "<th>Product Name</th>"
							str += "<th>Quantity</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							var ref = 0
							for(var i = 0 ; i < data.length; i++){
								str += "<tr>"
								str += "<td>"+(i+1)+"</td>"
								str += "<td>"+data[i].product.productName+"</td>"
								str += "<td>"+data[i].quantity+"</td>"
								str += "</tr>"
								
								ref = data[i].orderHeader.reference
							}
							str += "</tbody>"
							str += "</table>"
						$('.modal-body').html(str)
						$('#modal').modal('show')
						$('#btn-save').off('click').on('click', function(){doneProcess(headerId, ref)}).html('CheckOut')
					}
				})
			}
			
			function doneProcess(headerId,ref){
				console.log(ref)
				console.log(headerId)
				var formdata = '{'
					formdata += '"id": '+headerId+','
					formdata += '"amount": "'+$('#totalAmount').val()+'",'
					formdata += '"reference": "'+ref+'"'
					formdata += '}'
					
					$.ajax({
						url: '/api/orderheader/done',
						type: 'put',
						contentType: 'application/json',
						data: formdata,	
						success: function(){
							location.href = 'indexapi'
						}	
					})	
			}
			
			function allOrder(){
				$.ajax({
					url: '/api/orderheader',
					type: 'get',
					contentType: 'application/json',
					success: function(data){
						var str = "<table border = '2' class = 'table' style = 'text-align: center;'>"
							str += "<thead>"
							str += "<tr>"
							str += "<th>No</th>"
							str += "<th>Amount</th>"
							str += "<th>Reference</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							for(var i = 0 ; i< data.length; i++){
								str += "<tr>"
								str += "<td>"+(1+i)+"</td>"
								str += "<td>"+data[i].amount+"</td>"
								str += "<td>"+data[i].reference+"</td>"
								str += "</tr>"	
							}
							
							str += "</tbody>"
							str += "</table>"
							
							$('#data-list').html(' ')
							$('#main-contain').html(str)
						
					}
				})
			}
		
		</script>
	</div>
</body>

</html>